"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.FeatureToggleComponent = void 0;
const tslib_1 = require("tslib");
// Copyright (c) 2023 Sourcefuse Technologies
//
// This software is released under the MIT License.
// https://opensource.org/licenses/MIT
const core_1 = require("@loopback/core");
const rest_1 = require("@loopback/rest");
const core_2 = require("@sourceloop/core");
const keys_1 = require("./keys");
const middlewares_1 = require("./middlewares");
const providers_1 = require("./providers");
const services_1 = require("./services");
let FeatureToggleComponent = class FeatureToggleComponent {
    constructor(application) {
        this.application = application;
        // Mount core component
        this.application.component(core_2.CoreComponent);
        this.application.middleware(middlewares_1.FeatureToggleActionMiddlewareInterceptor);
        this.providers = {
            [keys_1.StrategyBindings.FEATURE_FLAG_ACTION.key]: providers_1.FeatureFlagActionProvider,
            [keys_1.StrategyBindings.METADATA.key]: providers_1.FeatureFlagMetadataProvider,
        };
        this.services = [services_1.FeatureHandlerService];
    }
};
FeatureToggleComponent = tslib_1.__decorate([
    tslib_1.__param(0, (0, core_1.inject)(core_1.CoreBindings.APPLICATION_INSTANCE)),
    tslib_1.__metadata("design:paramtypes", [rest_1.RestApplication])
], FeatureToggleComponent);
exports.FeatureToggleComponent = FeatureToggleComponent;
//# sourceMappingURL=component.js.map